<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Ejemplo Vue</title>

    <!-- En este ejemplo vamos a utilizar directamente el CDN -->
    <script src="https://unpkg.com/vue@3/dist/vue.global.js" defer></script>
    <script src="04-ejemplo-v-if.js" defer></script>
</head>
<body>

    <!-- 
        Ejemplo v-if y v-show
        https://es.vuejs.org/v2/guide/conditional.html

        IMPORTANTE: si un v-if y un v-for están en el mismo elemento, el v-if tiene precedencia pero la recomendación
        es que nunca estén los dos en el mismo elemento sino que se utilice anidamiento de elementos y que un elemento
        tenga como mucho una de las directivas.

            https://v3-migration.vuejs.org/breaking-changes/v-if-v-for.html

        En este ejemplo vamos a introducir personas de modo que se pueda actualizar de forma dinámica
        la lista de saludos.
    -->
    <div id="app">

        <!-- El texto lo voy a introducir con este input -->
        <input 
            type="text" 
            v-model="nuevaPersona" 
            v-on:keypress="addPersona($event)"
            >
                        
        <hr>

        <!-- El texto lo voy a introducir con este input utilizando un modificador de evento
            de modo que no sea necesario filtrar dentro del método por la tecla pulsada -->
        <input 
            type="text" 
            v-model="nuevaPersona" 
            v-on:keypress.enter="addPersonaMod()"
            >

        <hr>

        <!-- El v-for permite mostrar todas las personas -->
        <ul>
            <!-- Este elemento se va a replicar en función de una condición 
                Si pulsamos en saludar, se asignan las personas a saludar.
            -->
            <li v-for="persona in personas">                
                <span>{{ mensaje }}</span>
                <span> {{ persona.nombre }} </span> 
            </li>            
        </ul>

        <button v-on:click="saludar()">Saludar</button>

        <hr>
            <!-- 
                Ahora vamos a hacer que si hay más de 5 personas se muestre un mensaje que indique que son muchas 
                El v-if no renderiza ni hace nada si no se cumple la condición.
            -->
            <span v-if="personas.length > 5">v-if: Hala cuanta gente</span>
            
            <br>
            
            <!-- 
                Vamos ahora a utilizar v-show para mostrar la información 
                El v-show renderiza el componente aunque no se cumpla la condición pero asigna el 
                atributo css display:none para que no se muestre. 
            -->
            <span v-show="personas.length > 5">v-show: Hala cuanta gente</span>

        <hr>

        <!-- 
            En esta sección vemos como la propiedad es reactiva y cuando modificamos el contenido
            en el input, se actualiza la propiedad
        -->
        <h2>Debug</h2>
        <ul>
            <li>nuevaPersona = {{ nuevaPersona }}</li>
        </ul>
    </div>

    <h2>Prueba</h2>
    <button v-on:keypress="hola($event)">Prueba</button>

</body>
</html>